<i18n lang="yml">
  en:
    district: "District"
    cluster_location: "Container location"
    quarter: "Quarter"
    area: "Area"
    all: "All"
    crow_odk_scores: "CROW and ODK scores"
    crow: "CROW"
    odk: "ODK"
    amount_of_trash_per_type: "Amount of trash per type"
    current_cycle: "Current cycle"
    to: "to"
    week: "Week"
    day: "Day"
  nl:
    district: "Stadsdeel"
    cluster_location: "Containerlocatie"
    quarter: "Wijk"
    area: "Gebied"
    all: "Alle"
    crow_odk_scores: "CROW en ODK scores"
    crow: "CROW"
    odk: "ODK"
    amount_of_trash_per_type: "Hoeveelheid afval per soort"
    current_cycle: "Huidige cyclus"
    to: "t/m"
    week: "Week"
    day: "Dag"
</i18n>

<template>
  <div :class="$style['strategic-panel-graphs']">
    <div class="flex flex-wrap justify-between min-w-full">
      <div class="flex flex-wrap">
        <AmsLabeledBreadcrumb
          v-for="breadcrumb in locationBreadcrumbs"
          :key="breadcrumb.label"
          :style="breadcrumb.style"
        >
          <template #label>
            {{ breadcrumb.label }}
          </template>

          <template #name>
            {{ breadcrumb.location }}
          </template>
        </AmsLabeledBreadcrumb>
      </div>

      <AmsToggle
        :options="[
          { value: 'week', label: $t('week') },
          { value: 'day', label: $t('day') },
        ]"
        :selected="timeScale"
        @toggle="setTimescale"
      />
    </div>

    <AmsConnectedScatterPlot
      :datasets="scoreDatasets"
      :x-axis="xAxis"
      :threshold-marker="thresholdMarker"
    >
      <template #graphtitle>
        <h2 class="pt-6 text-lg font-bold" style="margin-left: 30px;">
          {{ $t('crow_odk_scores') }}
        </h2>
      </template>

      <template #labels>
        <transition-group
          tag="div"
          name="fade-items"
          class="flex flex-wrap items-center justify-center w-full text-sm"
          style="margin-bottom: 0.75rem; padding-inline: 2rem;"
        >
          <AmsLabelSwitch
            v-for="label in scoreLabelsForSwitches"
            :key="label.id"
            :switch-key="label.id"
            :switch-checked="scoreGraphs[label.id].visible"
            :color="label.color"
            @on-input="switchGraphDisplay($event, label.id)"
          >
            <template #labelContent>
              {{ $t(label.id) }}
            </template>
          </AmsLabelSwitch>
        </transition-group>
      </template>
    </AmsConnectedScatterPlot>

    <AmsConnectedScatterPlot
      :datasets="compDisplacementsDatasets"
      :x-axis="xAxis"
      :y-axis="yAxisAmounts"
      :threshold-marker="thresholdMarker"
      style="margin-bottom: 30px;"
    >
      <template #graphtitle>
        <h2 class="pt-6 text-lg font-bold" style="margin-left: 30px;">
          {{ $t('amount_of_trash_per_type') }}
        </h2>
      </template>

      <template #labels>
        <transition-group
          tag="div"
          name="fade-items"
          class="flex flex-wrap items-center justify-center w-full text-sm"
          style="margin-bottom: 0.75rem; padding-inline: 4rem;"
        >
          <AmsLabelSwitch
            v-for="(label, index) in displacementsLabelsForSwitches"
            :key="label.id"
            :switch-key="label.id"
            :switch-checked="label.visible"
            :color="label.color"
            :checkmark-value="`${index + 1}`"
            @on-input="switchGraphDisplay($event, label.id)"
          >
            <template #labelContent>
              {{ $t(label.id) }}
            </template>
          </AmsLabelSwitch>
        </transition-group>
      </template>
    </AmsConnectedScatterPlot>
  </div>
</template>

<script lang="ts">
import {
  computed,
  defineComponent,
  inject,
  onMounted,
  ref,
  Ref,
  watch,
} from "@nuxtjs/composition-api";

// Utility libraries
import cloneDeep from "lodash/fp/cloneDeep";
import groupBy from "lodash/groupBy";
import { DateTime } from "luxon";
import * as d3Color from "d3-color";

// Composables
import { AxiosResponse } from "axios";
import useScoresPrep from "./composables/scores-prep";
import useGlobals from "~/composables/globals";
import useFetchData from "~/composables/fetch-data";

// Combine cherry-picked modules into new d3 object.
const d3 = Object.assign({}, d3Color);

interface Rating {
  date: string
  score: number
  week?: number
}

interface GraphProps {
  id: string
  color: string
  data: Rating[]
  visible: boolean
  minMax: any[]
}

interface ThresholdMarker {
  date: any
  title: string
  subTitle: string
}

export default defineComponent({
  name: "AmsStrategicPanelGraphs",

  components: {
    AmsLabeledBreadcrumb: () => import("~/components/_patterns/LabeledBreadcrumb/LabeledBreadcrumb.vue"),
    AmsToggle: () => import("~/components/_elements/Toggle/Toggle.vue"),
    AmsConnectedScatterPlot: () => import("~/components/_patterns/Charts/ConnectedScatterPlot.vue"),
    AmsLabelSwitch: () => import("~/components/_elements/LabelSwitch/LabelSwitch.vue"),
  },

  props: {
    contentOptions: {
      type: Object,
      default: null,
    },
  },

  setup () {
    const { DISTRICT_ID_MAP, GARBAGE_TYPE_MAP, COLORS } = useGlobals();
    const { STATE } = inject("store");
    const { fetchData } = useFetchData();
    const {
      fetchRatings,
      fetchDisplacementNumbers,
    } = useScoresPrep();

    // Map urgency integers (1 to and including 5) to ODK and CROW scores.
    const URGENCY_TO_SCORE = [null, "A+", "A", "B", "C", "D"];

    // The desired location granularity: "district" or a container cluster's "address".
    const locLevel = computed(() => {
      return STATE.filters.valueFor.cluster_location?.length > 0 ? "address" : "district";
    });

    const __MOCK_NOW__ = "2020-12-10";

    const cycleData = ref(null);

    const fetchedCycleData = fetchData("cycles/current");
    fetchedCycleData
      .then((res: AxiosResponse) => res.data)
      .then((data: any) => {
        cycleData.value = {
          name: data.naam,
          startDate: DateTime.fromISO(data.start_date),
          endDate: DateTime.fromISO(data.end_date),
        };
      })
      .catch(console.error)
    ;

    const thresholdMarker: Ref<ThresholdMarker> = computed(() => {
      if (cycleData.value) {
        return {
          date: cycleData.value.startDate,
          title: "Current cycle",
          subTitle: `${cycleData.value.startDate.toLocaleString(DateTime.DATE_MED_WITH_WEEKDAY)} to ${cycleData.value.endDate.toLocaleString(DateTime.DATE_MED_WITH_WEEKDAY)}`,
        };
      } else {
        return null;
      }
    });

    // X-axis time scale; can be "week" or "day".
    const timeScale = ref("week");

    function setTimescale (value: string) {
      timeScale.value = value;
    }

    // Number of days that should be in the range.
    const timeRange = {
      week: 56,
      day: Math.abs(Number(DateTime.fromISO(__MOCK_NOW__).minus({ week: 1 }).startOf("week").diff(DateTime.fromISO(__MOCK_NOW__)).toFormat("d"))) || 12,
    };

    // Compute the x-axis properties which depends on requested time scale: "week" or "day".
    const xAxis = computed(() => {
      return {
        label: "Date",
        id: "date",
        type: "date",
        domain: [DateTime.fromISO(__MOCK_NOW__).minus({ days: timeRange[timeScale.value] }).toJSDate(), DateTime.fromISO(__MOCK_NOW__).toJSDate()],
        format: timeScale.value,
      };
    });

    const yAxisDomain = ref([0, 100]);

    const yAxisAmounts = computed(() => {
      return {
        label: "Amount",
        id: "amount",
        type: "number",
        domain: yAxisDomain.value,
        ticks: 5,
        scale: "linear",
      };
    });

    const locationBreadcrumbs = computed(() => {
      const breadcrumbs = [
        {
          label: "District",
          location: STATE.filters.valueFor.district,
          style: "margin-right: 1.5rem;",
        },
      ];

      if (STATE.filters.valueFor.cluster_location) {
        breadcrumbs.push({
          label: "Container location",
          location: STATE.filters.valueFor.cluster_location,
          style: null,
        });
      }

      return breadcrumbs;
    });

    /**
     * Show or hide each graph on user action.
     *
     * @param { boolean } checked - Is the switch-label checked or not?
     * @param { string } graph - What graph should be switched on or off?
     */
    function switchGraphDisplay (checked = true, graph = "odk") {
      if (graph === "odk" || graph === "crow") {
        const _datasets = cloneDeep(scoreDatasets.value);

        _datasets.find(set => set.id === graph).visible = checked;

        scoreDatasets.value = _datasets;
      } else {
        const _datasets = cloneDeep(displacementsDatasets.value);

        const visibleSubset = _datasets.filter(ds => ds.visible);

        // Below block ensures that only a maximum of three graphs are visible.
        // If a new graph is switched on by the user and there are already three graphs visible the graph with the lowest maximum is switched off.
        if (visibleSubset.length > 2) {
          const lastVisibleGraphId = visibleSubset.reverse().find(ds => ds.visible).id;

          let indexOfGraphToHide = null;

          _datasets.forEach((ds, index) => {
            if (_datasets.findIndex(d => d.id === graph) <= 2) {
              indexOfGraphToHide = _datasets.findIndex(d => d.id === lastVisibleGraphId) > 2 && checked ? _datasets.findIndex(d => d.id === lastVisibleGraphId) : null;
            } else if (ds.id !== graph && ds.visible && index >= 2) {
              indexOfGraphToHide = index;
            }
          });

          if (indexOfGraphToHide !== null && _datasets[indexOfGraphToHide]) {
            _datasets[indexOfGraphToHide].visible = false;
          }
        }

        _datasets.find(set => set.id === graph).visible = checked;

        displacementsDatasets.value = _datasets;
      }
    }

    const GRAPH_SCHEMA = {
      week: {
        district: {
          all: [],
        },
        address: {},
      },
      day: {
        district: {
          all: [],
        },
        address: {},
      },
    };

    // Schema and starting point for score graph.
    const scoreGraphs = {
      odk: {
        visible: true,
        color: COLORS.blue[700],
        scores: cloneDeep(GRAPH_SCHEMA),
      },
    };

    // The resulting ODK and CROW scores graph properties with datasets embedded.
    const scoreDatasets: Ref<GraphProps[]> = ref([{
      id: "odk",
      color: COLORS.blue[700],
      data: [] as Rating[],
      visible: true,
      minMax: ["D", "A+"],
    }]);

    // Compute the id's and colours for each graph label.
    const scoreLabelsForSwitches = computed(() => {
      return scoreDatasets.value
        .filter(dataset => dataset.data.length > 0)
        .map((dataset) => {
          return {
            id: dataset.id,
            color: dataset.color,
          };
        })
      ;
    });

    /**
     * Get the avarage ODK or CROW rating for a ISO week.
     *
     * @param { array } dataset
     * @param { string } key
     *
     * @returns { array }
     */
    function getAvgPerWeek (dataset: any[] = [], key = "score") {
      const clonedDataset = cloneDeep(dataset);

      const dataToWeeks = clonedDataset.map((d) => {
        d.week = DateTime.fromISO(d.date).weekNumber;

        return d;
      });

      const groupedByWeek = groupBy(dataToWeeks, "week");

      return Object.values(groupedByWeek).map((week) => {
        const sum = week.reduce((acc, cur) => acc + cur[key], 0);
        const avg = Math.round(sum / week.length);

        const obj: any = {};

        obj.date = DateTime.fromISO(week[0].date).startOf("week").toISODate();

        obj[key] = avg;

        return obj;
      });
    }

    /**
     * Populate the score datasets with massaged data.
     */
    function populateScoreDatasets () {
      let _datasets = [];

      Object.entries(scoreGraphs).forEach(([key, val]) => {
        let dataset = scoreGraphs[key].scores[timeScale.value][locLevel.value];

        if (locLevel.value === "district") {
          dataset = dataset[STATE.filters.valueFor.district] ? dataset[STATE.filters.valueFor.district] : [];
        } else {
          dataset = dataset[STATE.filters.valueFor.cluster_location] ? dataset[STATE.filters.valueFor.cluster_location] : [];
        }

        // Reduce the amount of data to the graph scale.
        dataset = dataset
          .filter((d) => {
            return DateTime.fromISO(d.date) > DateTime.fromISO(__MOCK_NOW__).minus({ days: timeRange[timeScale.value] }) && DateTime.fromISO(d.date) <= DateTime.fromISO(__MOCK_NOW__);
          })
          .map((d) => {
            const clonedDataset = cloneDeep(d);

            clonedDataset.score = URGENCY_TO_SCORE[d.score];

            return clonedDataset;
          })
        ;

        _datasets = [..._datasets, {
          id: key,
          color: val.color,
          data: dataset as Rating[],
          visible: val.visible,
          minMax: ["D", dataset.reduce((acc, cur) => acc >= cur.score ? acc : cur.score, 0)],
        }];
      });

      scoreDatasets.value = _datasets;
    }

    /**
     * Retrieve the ODK scores and then populate the datasets.
     *
     * @param { object } forLocation - Object with district and cluster_location props.
     */
    function retrieveRatings (forLocation = {
      district: STATE.filters.valueFor.district,
      cluster_location: STATE.filters.valueFor.cluster_location,
    }) {
      const locName = forLocation[locLevel.value === "address" ? "cluster_location" : locLevel.value];

      let locLvl: string | null = locLevel.value;
      let locId: string | null = null;

      if (locLevel.value === "district") {
        locId = DISTRICT_ID_MAP[locName];
        locLvl = locId === null ? locId : "stadsdeel";
      } else if (locLevel.value === "address") {
        const identifiers = Object.values(STATE.clusterIds).find((ids: any) => ids.address === locName);
        // @ts-ignore
        locId = identifiers ? identifiers.id : 1;
        locLvl = "cluster";
      }

      Object.keys(scoreGraphs).forEach((graph) => {
        const fetchedRatings = fetchRatings(graph, locLvl, locId);

        fetchedRatings
          .then((data: Rating[]) => {
            const dataPerTimeScale = {
              week: getAvgPerWeek(data, "score"),
              day: data,
            };

            ["week", "day"].forEach((time) => {
              scoreGraphs[graph].scores[time][locLevel.value][locName] = dataPerTimeScale[time];
            });
          })
          .then(() => setTimeout(populateScoreDatasets, 100))
          .catch(console.error)
        ;
      });
    }

    const blueDark = d3.color("#004699");
    const blueLight = d3.color("#3e89e3");
    const blueLighter = d3.color("#a9cef8");

    const SHADES_OF_BLUE = [blueDark, blueLight, blueLighter];

    // Schema and starting point for displacements graph.
    const displacementsGraphs = {
      bags: {
        visible: true,
        color: d3.color("#BADA55"),
        amounts: cloneDeep(GRAPH_SCHEMA),
      },
      wood: {
        visible: true,
        color: d3.color("#BADA55"),
        amounts: cloneDeep(GRAPH_SCHEMA),
      },
      cardboard: {
        visible: true,
        color: d3.color("#BADA55"),
        amounts: cloneDeep(GRAPH_SCHEMA),
      },
      matrasses: {
        visible: true,
        color: d3.color("#BADA55"),
        amounts: cloneDeep(GRAPH_SCHEMA),
      },
      furniture: {
        visible: true,
        color: d3.color("#BADA55"),
        amounts: cloneDeep(GRAPH_SCHEMA),
      },
      plastic: {
        visible: true,
        color: d3.color("#BADA55"),
        amounts: cloneDeep(GRAPH_SCHEMA),
      },
      carpet: {
        visible: true,
        color: d3.color("#BADA55"),
        amounts: cloneDeep(GRAPH_SCHEMA),
      },
      appliance: {
        visible: true,
        color: d3.color("#BADA55"),
        amounts: cloneDeep(GRAPH_SCHEMA),
      },
    };

    // The resulting ODK and CROW scores graph properties with datasets embedded.
    const displacementsDatasets: Ref<GraphProps[]> = ref([
      {
        id: "bags",
        color: displacementsGraphs.bags.color,
        data: [],
        visible: false,
        minMax: [],
      },
      {
        id: "wood",
        color: displacementsGraphs.wood.color,
        data: [],
        visible: false,
        minMax: [],
      },
      {
        id: "cardboard",
        color: displacementsGraphs.cardboard.color,
        data: [],
        visible: false,
        minMax: [],
      },
      {
        id: "matrasses",
        color: displacementsGraphs.matrasses.color,
        data: [],
        visible: false,
        minMax: [],
      },
      {
        id: "furniture",
        color: displacementsGraphs.furniture.color,
        data: [],
        visible: false,
        minMax: [],
      },
      {
        id: "plastic",
        color: displacementsGraphs.plastic.color,
        data: [],
        visible: false,
        minMax: [],
      },
      {
        id: "carpet",
        color: displacementsGraphs.carpet.color,
        data: [],
        visible: false,
        minMax: [],
      },
      {
        id: "appliance",
        color: displacementsGraphs.appliance.color,
        data: [],
        visible: false,
        minMax: [],
      },
    ]);

    const compDisplacementsDatasets = computed(() => {
      const datasets = cloneDeep(displacementsDatasets.value);

      let visibleNum = -1;

      datasets.forEach((ds) => {
        visibleNum = visibleNum < 2 ? visibleNum + 1 : 2;

        const shadeForDataset = SHADES_OF_BLUE[visibleNum].formatHex();

        ds.color = ds.visible ? shadeForDataset : SHADES_OF_BLUE[2].formatHex();
      });

      return datasets;
    });

    // Compute the id's and colours for each graph label.
    const displacementsLabelsForSwitches = computed(() => {
      let visibleNum = -1;

      return displacementsDatasets.value
        .filter(dataset => dataset.data.length > 0)
        .map((dataset) => {
          const visible = dataset.visible;

          if (visible) { visibleNum += 1; }

          return {
            id: dataset.id,
            color: visible
              ? SHADES_OF_BLUE[visibleNum].formatHex() || blueLighter.formatHex()
              : d3.color(COLORS.gray[200]).formatHex(),
            visible,
          };
        })
      ;
    });

    /**
     * Populate the displaced trash datasets with massaged data.
     */
    function populateDisplacementsDatasets () {
      const maxAmounts = [];

      let _datasets = [];

      Object.entries(displacementsGraphs).forEach(([graphKey, graphVal]) => {
        let maxAmount = null;
        let dataset = displacementsGraphs[graphKey].amounts[timeScale.value][locLevel.value];

        if (locLevel.value === "district") {
          dataset = dataset[STATE.filters.valueFor.district] ? dataset[STATE.filters.valueFor.district] : [];
        } else {
          dataset = dataset[STATE.filters.valueFor.cluster_location] ? dataset[STATE.filters.valueFor.cluster_location] : [];
        }

        // Reduce the amount of data to the graph scale.
        dataset = dataset
          .filter((d) => {
            const dDate = DateTime.fromISO(d.date);

            return dDate > DateTime.fromISO(__MOCK_NOW__).minus({ days: timeRange[timeScale.value] }) && dDate <= DateTime.fromISO(__MOCK_NOW__);
          })
          .map((d) => {
            const clonedDataset = cloneDeep(d);

            clonedDataset.amount = d.amount;

            return clonedDataset;
          })
        ;

        maxAmount = dataset.reduce((acc, cur) => acc >= cur.amount ? acc : cur.amount, 0);
        maxAmounts.push(maxAmount);

        _datasets = [..._datasets, {
          id: graphKey,
          color: d3.color(graphVal.color).formatHex(),
          data: dataset,
          visible: false,
          minMax: [0, maxAmount],
        }];
      });

      _datasets
        .sort((a, b) => {
          const maxAmountA = a.minMax[1];
          const maxAmountB = b.minMax[1];

          return maxAmountA < maxAmountB ? 1 : -1;
        })
        .forEach((ds, index) => {
          ds.visible = index < 3;
        })
      ;

      const domainMax = (() => {
        let multiple = maxAmounts.reduce((acc, cur) => cur > acc ? cur : acc, 0) * 1.2;

        if (multiple <= 8) {
          multiple = 8;
        } else if (multiple <= 10) {
          multiple = 10;
        } else {
          multiple = Math.ceil(multiple / 16) * 16;
        }

        return multiple;
      })();

      yAxisDomain.value = [0, domainMax];

      displacementsDatasets.value = _datasets;
    }

    /**
     * Retrieve the number of displacements per trash type and then populate the datasets.
     *
     * @param { object } forLocation - Object with district and cluster_location props.
     */
    function retrieveDisplacementNumbers (forLocation = {
      district: STATE.filters.valueFor.district,
      cluster_location: STATE.filters.valueFor.cluster_location,
    }) {
      const locName = forLocation[locLevel.value === "address" ? "cluster_location" : locLevel.value];

      let locLvl = locLevel.value;
      let locId = null;

      if (locLevel.value === "district") {
        locId = DISTRICT_ID_MAP[locName];
        locLvl = locId === null ? locId : "stadsdeel";
      } else if (locLevel.value === "address") {
        const identifiers = Object.values(STATE.clusterIds).find((ids: any) => ids.address === locName);
        // @ts-ignore
        locId = identifiers ? identifiers.id : 1;
        locLvl = "cluster";
      }

      const datasetDummy = [{
        date: "2020-10-15",
        amount: 0,
      }];

      const fetchedNumbers = fetchDisplacementNumbers(locLvl, locId);

      fetchedNumbers
        .then((data: any) => {
          Object.entries(displacementsGraphs).forEach(([graphKey, graphData]) => {
            const processedData = data
              .filter(data => data[GARBAGE_TYPE_MAP[graphKey]] > 0)
              .map((data) => {
                const dataPoint = cloneDeep(datasetDummy[0]);

                dataPoint.date = data.performed_at;
                dataPoint.amount = data[GARBAGE_TYPE_MAP[graphKey]];

                return dataPoint;
              })
            ;

            const dataPerTimeScale = {
              week: getAvgPerWeek(processedData, "amount"),
              day: processedData,
            };

            ["week", "day"].forEach((time) => {
              graphData.amounts[time][locLevel.value][locName] = dataPerTimeScale[time];
            });
          });
        })
        .then(() => setTimeout(populateDisplacementsDatasets, 100))
        .catch(error => console.error(error))
      ;
    }

    onMounted(() => {
      retrieveRatings();
      retrieveDisplacementNumbers();
    });

    watch(
      [
        () => STATE.filters.valueFor.district,
        () => STATE.filters.valueFor.cluster_location,
      ], (newValues) => {
        retrieveRatings({
          district: newValues[0],
          cluster_location: newValues[1],
        });
        retrieveDisplacementNumbers({
          district: STATE.filters.valueFor.district,
          cluster_location: STATE.filters.valueFor.cluster_location,
        });
      },
    );

    watch(
      () => timeScale.value,
      () => {
        retrieveRatings({
          district: STATE.filters.valueFor.district,
          cluster_location: STATE.filters.valueFor.cluster_location,
        });
        retrieveDisplacementNumbers({
          district: STATE.filters.valueFor.district,
          cluster_location: STATE.filters.valueFor.cluster_location,
        });
      },
    );

    return {
      STATE,
      timeScale,
      setTimescale,
      xAxis,
      yAxisAmounts,
      locationBreadcrumbs,
      thresholdMarker,
      scoreGraphs,
      scoreDatasets,
      scoreLabelsForSwitches,
      switchGraphDisplay,
      displacementsGraphs,
      compDisplacementsDatasets,
      displacementsLabelsForSwitches,
    };
  },
});
</script>

<style lang="postcss" module>
.strategic-panel-graphs {
  padding: 30px;

  @apply bg-gray-150 text-left select-none overflow-auto;

  @screen lg {
    height: 100%;
    height: calc(100vh - var(--appheader-height, 4.375rem));
  }
}
</style>
